#全角英数記号のうちでファイルに使用可能なもののみ半角に変換
function global:Zen2HanForFile($src){
	$diff = ([int[]]'！'.tochararray())[0] -([int[]]'!'.tochararray())[0]

	$tgtarray = [int[]]$src.ToCharArray();
#	$match = [regex] "[ａ-ｚＡ-Ｚ０-９！＠＃＄％＾＆（）−＿＋＝｀｛｝；，．]"
	$eisu = [int[]]"ａｚＡＺ０９".ToCharArray();
	$kigo = [int[]]"！＠＃＄％＾＆（）−＿＋＝｀｛｝；，．".ToCharArray();
	for($i = 0; $i -lt $tgtarray.length; $i++){
		$tmp = $tgtarray[$i];
		#英数チェック
		if( (( $tmp -ge $eisu[0] ) -and ( $tmp -le $eisu[1] ))	-or # [ａ-ｚ]
		    (( $tmp -ge $eisu[2] ) -and ( $tmp -le $eisu[3] ))	-or # [Ａ-Ｚ]
				(( $tmp -ge $eisu[4] ) -and ( $tmp -le $eisu[5] )) ){  # [０-９]
			$tgtarray[$i] -= $diff;
			continue;
		}
		
		#記号チェック
		for( $j =0; $j -lt $kigo.length; $j++ ){
			if($tmp -eq $kigo[$j]){
				$tgtarray[$i] -= $diff;
				break;
			}
		}
	}

	$x = '';
	for($i = 0; $i -lt $tgtarray.length; $i++){
		$x += [Char]$tgtarray[$i];
	}
	$x = $x -replace "[ 　]+", ' ';	 #1文字以上の全半角スペースを1半角スペースに	
#	$x = $x -replace "`”", "`"";	
#	$x = $x -replace "`“", "`"";	
	$x = $x -replace "`’", "`'";	
	
	return "$x"
}	


foreach( $eachpath in $args ){
#	"Old Path =" + $eachpath	
	$oldfile = Split-Path -leaf $eachpath
	$folder = Split-Path $eachpath

	$newfile = Zen2HanForFile "$oldfile"
	#$newfile
	$newpath = Join-Path "$folder" "$newfile"
# "New Path =" + $newpath
	#rename-item old new とする場合、パス名oldに[]が含まれると
	#正常動作しないので次の2行をenableとすること。
	#ちなみにパス名newに[]が含まれているのは問題ない。

	#$eachpath = $eachpath -replace "\[", "``["
	#$eachpath = $eachpath -replace "\]", "``]"

	#Test-Path -LiteralPath "$eachpath"
	move-item -LiteralPath "$eachpath" "$newpath"
	#rename-item "$eachpath" "$newpath"
}

#Read-Host "key in"